__author__ = 'kickass'
import os, sys, tkFileDialog
from Tkinter import *

validList=[]

class kickassRenamer(Frame):

    def __init__(self, master):

        Frame.__init__(self, master)
        self.highlightthickness=0

    def getfilesindir(self, trigger):
        if not fromsuffix.get():
            label1.config(text="Enter suffixes (casesensitive) and push the folder.")
            return
        elif not tosuffix.get():
            label1.config(text="Enter suffixes (casesensitive) and push the folder.")
            return
        else:
            global validList
            validList=[]
            global givendir
            try:
                givendir=tkFileDialog.askdirectory(parent=root)
            except OSError as err:
                label1.config(text=str(err))
            global numberofdiritems
            try:
                numberofdiritems=len(os.listdir(givendir))
            except OSError as err:
                label1.config(text=str(err))
            print str(numberofdiritems)+" items in that directory."
            print fromsuffix.get().strip('.')
            global dirList
            try:
                dirList=os.listdir(givendir)
            except OSError as err:
                label1.config(text=str(err))
            for fname in dirList:
                if fname.endswith("."+fromsuffix.get().strip('.')):
                    validList.append(givendir+"/"+fname)
            global numberofvaliditems
            numberofvaliditems=len(validList)
            label1.config(text=str(numberofvaliditems)+"/"+str(numberofdiritems)+" items match given criteria!")
            if numberofvaliditems > 0:
                button2.config(image=buttonimage2)
                button2.status="on"
                return validList
            else:
                button2.config(image=buttonimage1)
                button2.status="off"
                return

    def renamefiles(self, trigger):
        if button2.status == "on":
            label1.config(text="Renaming files...")
            for i in validList:
                os.rename(i, str(i.split(".")[0]+"."+tosuffix.get().strip('.')))
            label1.config(text=str(numberofvaliditems)+" files were renamed!")
            button2.status="off"
            button2.config(image=buttonimage1)
        else:
            label1.config(text="Enter suffixes (casesensitive) and push the folder.")



if __name__=='__main__':
    mypath=sys.path[0]
    root = Tk()
    root.title("A kickass Renamer Beta 0.1")
    root.geometry('350x200-500+400')
    root.resizable(width=False, height=False)

    mainwindow = kickassRenamer(root)
    mainwindow.grid(sticky=W+E+N+S)
    background1_gif = PhotoImage(file=mypath+'/back1.gif')
    background2_gif = PhotoImage(file=mypath+'/back2.gif')
    buttonimage1 = PhotoImage(file=mypath+'/rename_gray.gif')
    buttonimage2 = PhotoImage(file=mypath+'/rename.gif')
    button1 = Label(root, image= background1_gif, borderwidth=0, highlightthickness=0)
    button1.image = background1_gif
    button1.bind("<Button-1>", mainwindow.getfilesindir)
    button1.grid(row=0, rowspan=10, column=0, columnspan=1)

    body = Label(root, image= background2_gif, borderwidth=0, highlightthickness=0)
    body.image = background2_gif
    body.grid(row=0, rowspan=10, column=1, columnspan=10)
    fromsuffix = Entry(root, width=3)
    fromsuffix.grid(row=4, column=3, padx=0, pady=0)
    fromsuffix.focus()
    tosuffix = Entry(root, width=3)
    tosuffix.grid(row=4, column=7, padx=0, pady=0)
    button2 = Label(root, image=buttonimage1, borderwidth=0, highlightthickness=0)
    button2.image = buttonimage1
    button2.status = "off"
    button2.bind("<Button-1>", mainwindow.renamefiles)
    button2.grid(row=5, column=2, columnspan=7, rowspan=4)
    label1 = Label(root, text="Enter suffixes (casesensitive) and push the folder.", font=("Helvetica", 8), bg="darkgray")
    label1.grid(row=9, column=3, columnspan=7, padx=0, pady=0, sticky=W+E)
    root.mainloop()
